 	jQuery(document).ready(function($) {

	    // Menu Mobile
	    $('.btn_menu').on('click', function (e){
	    	e.preventDefault();
	    	$(this).parents().find('.menu_mobile').toggleClass('open_menu');
	    	$(this).parents().find('.overlay_menu').toggleClass('show_overlay');
	    });

	     $('.close_menu').on('click', function (e){
	    	e.preventDefault();
	    	$(this).parents().find('.menu_mobile').toggleClass('open_menu');
	    	$(this).parents().find('.overlay_menu').toggleClass('show_overlay');
	    });

	    $(".overlay_menu").on("click", function (){
        	$(this).parents().find('.menu_mobile').toggleClass('open_menu');
	    	$(this).parents().find('.overlay_menu').toggleClass('show_overlay');                 
    	});

    	$(".toggle_menu").on("click", function (e){
    		e.preventDefault();
        	$(this).parent().find('.sub_menu').slideToggle();
    	});

    	function enjson(str) {
				return btoa(encodeURIComponent(JSON.stringify(str)));
		}
		
		function dejson(str) {
			return JSON.parse(decodeURIComponent(atob(str)));
		}

    	// Hero slider
    	$('.owl-carousel').owlCarousel({
		    loop:true,
		    margin:10,
		    nav:false,
		    dots:false,
		    animateOut: 'fadeOut',
		    responsive:{
		        0:{
		            items:1
		        },
		        600:{
		            items:1
		        },
		        1000:{
		            items:1
		        }
		    }
		});
		
		$('.lumise-filter').find('input, select').on('change', function (){
			var checkedItem = [];
			$(this).closest('form').find(':input:checked').each(function(){
				checkedItem.push( this.value );
			});

			//get current url query string
			const params = new URLSearchParams(window.location.search);
			let category_id = params.get('category_id');
			let product_filter = params.get('product_filter');

			//set new param values
			params.set('product_filter', checkedItem.join(','));

			//make new url
			let newHome = window.location.origin+'/products.php?'+params.toString();

			//change form url
			window.location.href = newHome;
		});

		$('#country').on('change', function(e){
			const nonce = $('input[name="nonce"]').val();
			const ajax_url = $('input[name="ajax_url"]').val();
			let country = this.value;

			$.ajax({
				url: ajax_url,
				method: 'POST',
				data: {
					nonce: 'LUMISE-SECURITY:'+nonce,
					ajax: 'backend',
					action: 'apply_shipping',
					task: '',
					country:country,
					 
				},
				statusCode: {
					403: function(){
						alert('Error 403');
					}
				},
				success:  function(res) {
					$('tr#shipping').html('<td colspan="4" class="text-right"><strong>Shipping</strong><p class="mb-0">'+res.title+'</p></td><td class="text-right">'+res.text+'<td>');
					let current_total = $('td#total').data('total');
					current_total = parseFloat(current_total);


					let total = current_total+res.cost;

					$('td#total').html('$'+total);				
				}
			});
		});

		//Upload your design-file upload
		$('body').on('change','.img-upload', function(e){
			//console.log(this.files);
			$(this).parent().next().html('<b class="mt-3">File Selected: '+this.files[0].name + '</b>')
			
		});	

		//file handle , .qs-file-handle ( input class )
		$('.form-page').on('change','.qs-file-handle', function(e){
			
			const __this = $(this);
			const nonce = $('input[name="nonce"]').val();
			const ajax_url = $('input[name="ajax_url"]').val();
			

			//console.log(nonce);
			//return;
			
			var frm = new FormData();
			frm.append('files', __this[0].files[0]);
			frm.append('nonce', 'LUMISE-SECURITY:'+nonce);
			frm.append('ajax', 'backend');
			frm.append('action', 'handle_qs_file_upload');
			frm.append('field', __this.attr('name'));
			frm.append('task','');

			
			$.ajax({
				xhr: function() {
	                var xhr = new window.XMLHttpRequest();
	                xhr.upload.addEventListener("progress", function(evt) {
	                    if (evt.lengthComputable) {
	                        var percentComplete = ((evt.loaded / evt.total) * 100);
	                        __this.parent().parent().find('.msg').html(parseInt(percentComplete)+'% uploading...');
	                        
	                    }
	                }, false);
	                return xhr;
		        },
		        
				url: ajax_url,
				method: 'POST',
				data: frm,
				contentType: false,
	            cache: false,
	            processData:false,
				statusCode: {
					403: function(){
						alert('Error 403');
						window.location.reload();
					}
				},
				beforeSend: function(){
					__this.parent().parent().find('.msg').remove();
					__this.parent().parent().append('<p class="msg">0% uploading...</p>');
				},
				success:  function(res) {
					//console.log(res);
					__this.parents('form').find('#qs_uploade_files').remove();

					if(typeof res.uploaded_files!==undefined){
						__this.parents('form').append('<input type="hidden" name="uploaded_files" id="qs_uploade_files" value="'+JSON.stringify(res.uploaded_files)+'">');
						__this.parent().parent().find('.msg').html('Uploaded.');
						$('input[name="nonce"]').val(res.token);
						$('#msg').html(res.msg);
					}
					
					
				},
			});
		});

		//step form for questionnaire and validation
		var $wizard = $('#qs-form').steps({

			headerTag: "h2",
            bodyTag: "section",
            labels:{
            	finish:'Submit',
            },
            ignore:'.lumise-cart-param, :disabled, :hidden',

            
            onStepChanging:function(event, currentIndex, newIndex) {
            	var form = $(this);

            	//skip validation if going to prev step
            	if( currentIndex > newIndex ) {
            		return true;
            	}
            	//ignore hidden and disabled field
            	form.validate().settings.ignore = ":disabled, :hidden";

                // Start validation; Prevent form submission if false
                return form.valid();
            },

            onFinishing:function(event, currentIndex) {
            	//display loader on submit
            	document.getElementById('loader').style.display='flex';

            	var form = $(this);

            	//ignore hidden and disabled field
            	form.validate().settings.ignore = ":disabled, :hidden";

                // Start validation; Prevent form submission if false
                let result =  form.valid();
                if( !result ) {
                	document.getElementById('loader').style.display='none';
                }
                return result;
            },

            onFinished: function(event, currentIndex) {

            	var form = $(this);
            	form.find('a[href="#finish"]').parent('li').addClass('disabled');

            	//if upload you own form
            	if( form.find('input[name="formtype"]').length == 1) {
            		product.cart.add_cart();
            		form.submit();
            		return;
            	}
            	
            	handleForm(event);
            	document.getElementById('loader').style.display='none';
            }     
		});

		$wizard.validate({
			errorPlacement: function(error, element) {
            	//console.log(element);
            	element.parents('section').append(error);
            },
		});

		$('.form-page .skipStep').on('click', function(e){
			e.preventDefault();
			let stepToSkip = $wizard.steps('getCurrentIndex');
			
			$('#qs-form-p-'+stepToSkip).find(':input').each(function(){
				
				if( (this.type != 'button') && this.hasAttribute('required') ){
					this.removeAttribute('required');
				}
			})

			$wizard.steps('next');
		});

		//handle pay button
		$('.form-page #qs_save_and_pay').on('click', function(e){

			e.preventDefault();
			$wizard.steps('finish');
		});	

		function handleForm(event) {
			event.preventDefault();

									
			var f = document.getElementById('qs-form'),
			 frm = new FormData(f),

			 nonce = $('input[name="nonce"]').val(),
			 ajax_url = $('input[name="ajax_url"]').val();

			frm.set('nonce','LUMISE-SECURITY:'+nonce),
			frm.append('ajax', 'backend'),
			frm.append('action','save_qs'),
			frm.append('task','')
			frm.append('qs_labels', JSON.stringify($qs_labels));


			$.ajax({
				url:ajax_url,
				method: 'POST',
				data: frm,
				contentType: false,
	            cache: false,
	            processData:false,
				statusCode: {
					403: function(){
						alert('Error 403');
						window.location.reload();
					}
				},
				success:function(d){
					$('input[name="nonce"]').val(d.token);
					$('#mesg').html(d.msg);

					if( d.redirect != false ) {
						window.location.href = d.redirect;
					}
				}
			})
		}

	});

