jQuery(document).ready(function ($) {

	window.lumise = {

		slugify: function (text) {

			var a = 'àáạäâãấầẫậạăắằẵặèéëêếềễẹệìíĩïîịòóöôốồỗộọùúüûũụùúũđñçßÿœæŕśńṕẃǵǹḿǘẍźḧ·/_,:;',
				b = 'aaaaaaaaaaaaaaaaeeeeeeeeeiiiiiiooooooooouuuuuuuuudncsyoarsnpwgnmuxzh------',
				p = new RegExp(a.split('').join('|'), 'g');

			return text.toString().toLowerCase()
				.replace(/\s+/g, '-')
				.replace(p, function (c) { return b.charAt(a.indexOf(c)); })
				.replace(/&/g, '-and-')
				.replace(/[^\w\-]+/g, '')
				.replace(/\-\-+/g, '-')
				.replace(/^-+/, '')
				.replace(/-+$/, '');

		},
		trigger: function (obj) {

			var func;
			for (var ev in obj.events) {

				if (typeof obj.events[ ev ] == 'function')
					func = obj.events[ ev ];
				else if (typeof obj[ obj.events[ ev ] ] == 'function')
					func = obj[ obj.events[ ev ] ];
				else continue;

				ev = ev.split(',');

				ev.map(function (evs) {

					evs = evs.split(':');

					if (evs[ 1 ] === undefined) evs[ 1 ] = 'click';

					if (evs[ 0 ] === '')
						obj.el.off(evs[ 1 ]).on(evs[ 1 ], obj, func);
					else obj.el.find(evs[ 0 ]).off(evs[ 1 ]).on(evs[ 1 ], obj, func);

				});

			}
		},
		fn: {
			price: function (p) {
				let price = this.number_format(
					parseFloat(p * 1),
					parseInt(2),
					'.',
					'.',
				);
				return ('1' === '0' ? price + '$' : '$' + price);
			},
			number_format: function (number, decimals, dec_point, thousands_sep) {
				// Strip all characters but numerical ones.
				number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
				var n = !isFinite(+number) ? 0 : +number,
					prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
					sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
					dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
					s = '',
					toFixedFix = function (n, prec) {
						var k = Math.pow(10, prec);
						return '' + Math.round(n * k) / k;
					};
				// Fix for IE parseFloat(0.55).toFixed(0) = 0;
				s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
				if (s[ 0 ].length > 3) {
					s[ 0 ] = s[ 0 ].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
				}
				if ((s[ 1 ] || '').length < prec) {
					s[ 1 ] = s[ 1 ] || '';
					s[ 1 ] += new Array(prec - s[ 1 ].length + 1).join('0');
				}
				return s.join(dec);
			}
		}
	}

	window.product = {

		data: {
			calc_formula: '0',
		},
		ops: {},

		fn: {
			enjson: function (str) {
				return btoa(encodeURIComponent(JSON.stringify(str)));
			},

			dejson: function (str) {
				return JSON.parse(decodeURIComponent(atob(str)));
			},
		},

		render: function (data) {

			//data = $.extend(true, {}, data);
			//console.log(data);
			if (data.variations !== undefined && data.variations !== '' && typeof data.variations == 'string') {
				data.variations = product.fn.dejson(data.variations);
			}

			if (data.attributes !== undefined && data.attributes !== '' && typeof data.attributes == 'string')
				data.attributes = product.fn.dejson(data.attributes);

			if (data.printings !== undefined && data.printings !== '' && typeof data.printings == 'string')
				data.printings = product.fn.dejson(data.printings);

			product.ops.product_data = data;


			var variations = data.variations !== undefined ? data.variations : {};

			product.data.variations = variations;

			var vari_data = product.process_variations(variations.default, null);

			data.attributes = vari_data.attributes;
			product.data.variation = vari_data.variation;
			product.data.attributes_cfg = data.attributes_cfg;

			product.product_attrs(vari_data);

			product.ops.product_data = data;
		},

		process_variations: function (values, el) {

			vari_data = {
				variation: null,
				name: product.ops.product_data.name,
				description: product.ops.product_data.description,
				price: product.ops.product_data.price,
				printings: $.extend(true, [], product.ops.product_data.printings),
				attributes: $.extend(true, {}, product.ops.product_data.attributes),
				stages: {},
				printing: null,
				variation_image: null,
			};

			// Set default form product_vairations	
			if (values !== null && typeof values == 'object') {
				Object.keys(values).map(function (k) {
					if (values[ k ] !== undefined && typeof values[ k ].trim == 'function')
						values[ k ] = values[ k ].trim();
					if (vari_data.attributes[ k ] !== undefined) {
						vari_data.attributes[ k ].value = values[ k ];
					} else if (k == 'printing') {
						vari_data.printing = values[ k ];
					}
				});
			}

			// if there are no variations
			if (
				typeof product.data.variations != 'object' ||
				product.data.variations.variations === undefined ||
				Object.keys(product.data.variations.variations).length === 0
			) {
				return vari_data;
			}


			// Get matched variation

			let obj = null,
				varis = product.data.variations;

			// Keep options of current trigger element

			varis.attrs.map(function (a) {
				vari_data.attributes[ a ].allows = [];
				if (el !== null && el !== undefined && a == el.name) {
					//console.log(a);
					vari_data.attributes[ a ].allows = product.ops.product_data.attributes[ a ].allows;
					vari_data.attributes[ a ].value = values[ el.name ];
				}
			});


			// Only show options of other attributes match with trigger_id 

			Object.keys(varis.variations).map(function (v) {

				let valid = true;

				Object.keys(varis.variations[ v ].conditions).map(function (c) {

					// Collect all match option value of OTHER attributes

					if (vari_data.attributes[ c ].allows === undefined)
						vari_data.attributes[ c ].allows = [ '' ];

					if (
						el !== null &&
						el !== undefined &&
						c != el.name &&
						(
							varis.variations[ v ].conditions[ el.name ] == '' || // condition attr c is any
							values[ el.name ] == '' || // trigger is any
							varis.variations[ v ].conditions[ el.name ] == values[ el.name ]
							// condition attr c match with trigger
						) &&
						vari_data.attributes[ c ].allows.indexOf(varis.variations[ v ].conditions[ c ]) === -1
					) {

						if (varis.variations[ v ].conditions[ c ] !== '')
							vari_data.attributes[ c ].allows.push(varis.variations[ v ].conditions[ c ]);
						else if (
							typeof vari_data.attributes[ c ].values == 'object' &&
							typeof vari_data.attributes[ c ].values.options == 'object'
						) {
							// if condition of variation is any, set allow all options of attr

							vari_data.attributes[ c ].values.options.map(function (op) {
								if (vari_data.attributes[ c ].allows.indexOf(op.value) === -1)
									vari_data.attributes[ c ].allows.push(op.value);
							});
						}

						if (values[ c ] == varis.variations[ v ].conditions[ c ])
							vari_data.attributes[ c ].value = values[ c ];
						vari_data.variation_image = varis.variations[ v ].variation_image

					} else if (el === null || el === undefined) {

						if (varis.variations[ v ].conditions[ c ] == '') {

							vari_data.attributes[ c ].allows = [ '' ];

							if (
								typeof vari_data.attributes[ c ].values == 'object' &&
								typeof vari_data.attributes[ c ].values.options == 'object'
							) {
								vari_data.attributes[ c ].values.options.map(function (op) {
									if (vari_data.attributes[ c ].allows.indexOf(op.value) === -1)
										vari_data.attributes[ c ].allows.push(op.value);
								});
							}
						} else if (vari_data.attributes[ c ].allows.indexOf(varis.variations[ v ].conditions[ c ]) === -1)
							vari_data.attributes[ c ].allows.push(varis.variations[ v ].conditions[ c ]);
					}

					// Check valid variation

					if (
						varis.variations[ v ].conditions[ c ] !== '' &&
						(
							values[ c ] === undefined ||
							varis.variations[ v ].conditions[ c ] != values[ c ]
						)
					) valid = false;
				});

				// Valid first variation

				if (valid && obj === null) {
					obj = varis.variations[ v ];
					obj.id = v;
				}

			});

			// Found a variation matchs with attribute values selected
			if (obj !== null) {

				[ 'price', 'sku', 'description', 'minqty', 'maxqty', 'variation_image' ].map(function (p) {

					if (obj[ p ] !== undefined && obj[ p ] !== null && obj[ p ] !== '')
						vari_data[ p ] = obj[ p ];
				});


				if (
					obj[ 'cfgprinting' ] === true &&
					obj[ 'printings' ] !== undefined &&
					obj[ 'printings' ] !== null &&
					obj[ 'printings' ] !== ''
				) {
					obj[ 'printings' ].map(function (p) {
						if (p[ 'calculate' ] && typeof p[ 'calculate' ] == 'string')
							p[ 'calculate' ] = product.fn.dejson(p[ 'calculate' ]);
					});
					vari_data[ 'printings' ] = $.extend(true, [], obj[ 'printings' ]);
					vari_data[ 'printings_cfg' ] = obj[ 'printings_cfg' ];
					vari_data[ 'cfgprinting' ] = true;
				};


				vari_data.variation = obj.id;

			}
			//console.log(vari_data);
			return vari_data;

		},
		product_attrs: function (data) {

			product.cart_change();
			product.cartrender(data);

		},
		cart_change: function () {



		},
		cartrender: function (data) {

			var attr = {},
				wrp = $('#lumise-cart-attributes');

			wrp.html('');

			if (data === undefined) {
				return;
			}

			Object.keys(data.attributes).map(function (k) {

				var attr = data.attributes[ k ];
				//console.log(attr);

				data.attributes[ k ].allows = attr.allows;

				if (attr.value === undefined) {
					//console.log(attr)
					if (typeof attr.values == 'object' && typeof attr.values.options == 'object') {

						attr.value = [];
						attr.values.options.map(function (o) {
							if (o.default === true)
								attr.value.push(o.value);
						});
						attr.value = attr.value.join(decodeURI("%0A"));
					} else if (typeof attr.values == 'object' && attr.values.default !== undefined) {
						attr.value = attr.values.default;
					} else attr.value = '';
				};

				if (attr.id === undefined) {
					attr.id = product.slug(attr.name);
				}
				//asign variation image
				attr.variation_image = data.variation_image;

				wrp.append(product.fields.render(attr));

				//wrp.append('<p>Hellow world</p>');

			});

			if (product.data.calc_formula == '1') {
				wrp.append(
					'<div class="lumise-cart-field how-calculate">\
						<a href="#formula">\
							'+ 'Price calculation formula' + '\
							<i class="lumisex-ios-arrow-forward"></i>\
						</a>\
					</div>'
				)
			};

			lumise.trigger({
				el: wrp,
				events: {
					'.lumise-cart-param:change': 'calc_cart',
					'a[href="#formula"]': 'formula'
				},
				calc_cart: function (e) {
					// hash : 2cca8dcd607566aec4da56227019f71f
					// make sesion local variable save satate dropdown change
					console.log('dropdown change');
					sessionStorage.setItem('LUMISE-PRINT-DROPDOWN', 'false');

					$('#lumise-cart-attributes em.lumise-required-msg').remove();

					product.cart.variations(this);
					product.cart.calc();

					product.cart_change();
					//lumise.actions.do('cart-changed', true);

				},
				formula: function (e) {

					e.preventDefault();

					var sum = product.cart.sum_calc(),
						table = '',
						print_detail = false;


					var varitxt = '',
						vr = (
							product.ops.product_data.variations !== undefined &&
							product.ops.product_data.variations.variations !== undefined &&
							product.ops.product_data.variations.variations[ product.data.variation ] !== undefined
						) ? product.ops.product_data.variations.variations[ product.data.variation ] : null;

					if (product.data.variation !== null && vr !== null) {
						varitxt += '<p class="notice">' +
							lumise.i(193) + ' <strong>#' + lumise.data.variation + '</strong>' +
							(vr.price !== '' ? ', ' + lumise.i(182) + ': <strong>' + vr.price + '</strong>' : '') +
							(vr.minqty !== '' ? ', min-qty: <strong>' + vr.minqty + '</strong>' : '') +
							(vr.maxqty !== '' ? ', max-qty: <strong>' + vr.maxqty + '</strong>' : '') +
							'</p>';
					}

					var item_price = sum.ext + sum.base + sum.template + product.cart.printing.calc(product.cart.qty);


				}
			});

			product.cart.calc();


		},
		cart: {

			data: {},

			price: {
				extra: {},
				base: 0,
				color: 0,
				attr: 0,
				fixed: 0,
				template: 0,
			},

			template: {},

			qty: 0,

			attr_tmpl: null,

			timer: null,

			add_cart: function () {

				let variation = JSON.stringify(product.data.variation);
				if (variation) {

					variation = variation.split('"').join('');
				}

				let options = JSON.stringify(product.cart.data.options);

				let inp = document.createElement('input');
				inp.type = "hidden";
				inp.name = "variation";
				inp.value = variation;


				let option = document.createElement('input');
				option.type = "hidden";
				option.name = "options";
				option.value = options;


				$('body').find('#qs-form').append(inp);
				$('body').find('#qs-form').append(option);

				//$('body').find('#qs-form').submit();
			},

			variations: function (el) {


				if (product.data.variations.attrs === undefined || product.data.variations.attrs.indexOf(el.name) === -1)
					return;

				var values = {};

				$('.lumise-cart-attributes .lumise-cart-param:not(.disabled)').serializeArray().map(function (x) {
					values[ x.name ] = x.value;
				});


				var vari_data = product.process_variations(values, el);

			
				// no variations change
				if (
					(
						vari_data.variation === null &&
						product.data.variation === null
					) ||
					product.data.variation == vari_data.variation
				) {
					return product.product_attrs(vari_data);
				}

				product.data.variation = vari_data.variation;
				product.product_attrs(vari_data);
				//console.log(product.data.variation);
			},

			sum_calc: function () {

				var prices = {},
					extra_filter = {};//product.apply_filters('product_extra_price', {}),
				price = product.cart.price.base + product.cart.price.color + product.ops.product_data.price;

				prices.base = price;
				price = 0;

				// base price

				var ext_price = Object.values(extra_filter).filter(
					price => typeof price !== 'object' && parseFloat(price) > 0
				);

				if (ext_price.length > 0)
					price += ext_price.reduce((a, b) => parseFloat(a) + parseFloat(b));

				//calc extra price from addons

				if (Object.keys(product.cart.price.extra).length > 0) {
					Object.values(product.cart.price.extra).map(function (objs) {
						objs.map(function (obj) {
							price += parseFloat(obj.price);
						});
					});
				}

				prices.ext = price;
				price = 0;

				// price template

				price += (
					Object.keys(product.cart.price.template).length > 0 &&
						Object.values(product.cart.price.template).filter(price => parseFloat(price)).length > 0 ?
						Object.values(product.cart.price.template).
							filter(price => parseFloat(price) >= 0).
							reduce((a, b) => parseFloat(a) + parseFloat(b)) :
						0
				);

				prices.template = price;
				return prices;

			},

			sum: function () {

				var price = this.sum_calc();
				
				return price.base + price.ext + price.template;

			},

			extra_price: function (ext_id, data) {

				if (data == null) {
					delete product.cart.price.extra[ ext_id ];
					return;
				};

				if (typeof product.cart.price.extra[ ext_id ] === 'undefined')
					product.cart.price.extra[ ext_id ] = [];

				//check exists id of resource
				var f = product.cart.price.extra[ ext_id ].filter(
					obj => obj.id == data.id && obj.table == data.table
				);

				if (typeof f[ 0 ] === 'undefined')
					product.cart.price.extra[ ext_id ].push(data);

			},

			get_price: function (f) {

				var price = 0,
					sum = product.cart.sum();

				if (isNaN(product.cart.qty) || product.cart.qty == 0)
					product.cart.qty = 1;

				price = sum;
				price += product.cart.price.fixed;
				return f === true ? [ price, product.cart.qty ] : price;

			},

			calc: function (states_data) {

				product.cart.data = {
					options: {},
				};

				product.cart.price.attr = 0;
				product.cart.price.fixed = 0;
				product.cart.qty = 0;

				var fields = $('.lumise-cart-attributes .lumise-cart-param:not(.disabled)').serializeArray(),
					attrs = product.ops.product_data.attributes;

				
				fields.map(function (field) {

					if (attrs[ field.name ] == undefined)
						return;

					var attr = attrs[ field.name ];


					if (field.value === '') {
						delete product.cart.data.options[ attr.id ];
					} else {
						if (!(attr.id in product.cart.data.options)) {
							product.cart.data.options[ attr.id ] = field.value;
						}
						else {
							product.cart.data.options[ attr.id ] += "\n" + field.value;
						}

					};

					if (attr.type == 'quantity') {

						if (!isNaN(parseInt(field.value))) {

							product.cart.qty += parseInt(field.value);



							if (
								attr.values !== undefined &&
								typeof attr.values == 'object' &&
								attr.values.type == 'package'
							) {

								var attr_price = attr.values.package_options.filter(function (o) {
									return o.value == field.value;
								});

								// calc attr price for quantity group
								if (
									attr_price.length > 0 &&
									attr_price[ 0 ].price !== '' &&
									!isNaN(parseInt(attr_price[ 0 ].price))
								) {
									//product.cart.price.attr += parseFloat(attr_price[0].price);
									// package price should not multiply with quantity. its should be fixed
									product.cart.price.fixed += parseFloat(attr_price[ 0 ].price)
								}
							}

						} else if (field.value !== '' && attr.values.type == 'multiple') {

							try {

								var qtys = JSON.parse(field.value);

								Object.keys(qtys).map(function (i) {

									if (!isNaN(parseInt(qtys[ i ]))) {

										product.cart.qty += parseInt(qtys[ i ]);

									}
								});
								// Calc attr price for multiple quantity 
								Object.keys(qtys).map(function (i) {

									var attr_price = attr.values.multiple_options.filter(function (o) {
										return o.value == i;
									});

									if (
										attr_price.length > 0 &&
										attr_price[ 0 ].price !== '' &&
										!isNaN(parseInt(attr_price[ 0 ].price)) &&
										!isNaN(parseInt(qtys[ i ]))
									) {
										product.cart.price.fixed += parseFloat(attr_price[ 0 ].price) * parseInt(qtys[ i ]);
									}

								});

							} catch (ex) { }

						}

					} else if (typeof attr.values == 'object' && typeof attr.values.options == 'object') {

						var attr_price;

						field.value.split(decodeURI("%0A")).map(function (v) {

							if (v === '')
								return;

							attr_price = attr.values.options.filter(function (o) {
								return o.value == v;
							});


							if (
								attr_price.length > 0 &&
								attr_price[ 0 ].price !== '' &&
								!isNaN(parseInt(attr_price[ 0 ].price))
							) {
								product.cart.price.attr += parseFloat(attr_price[ 0 ].price);
								
							}

						});

					}

				});

				//console.log(product.data.variation);
				if (product.ops.product_data.variations.variations) {

					var vari_price = null;
					var form_values = {};

					$('.lumise-cart-attributes .lumise-cart-param:not(.disabled)').serializeArray().map(function (x) {
						form_values[ x.name ] = x.value;
					});

					$.each(product.ops.product_data.variations.variations, function (vid, vari) {

						if ((vari_price == null) && (typeof vari.conditions == 'object') && (vari.price != '')) {
							
							var valid = true;
							$.each(vari.conditions, function(cid,cond) {
								if (
									cond!='' && 
									(
										typeof form_values !='object' ||
										!(cid in form_values) || 
										cond != form_values[cid]
									)
								) {
									valid = false;
								}
							})
							// console.log(vari.conditions);
							// console.log('============================')
							// console.log(form_values);
							// if( _.isEqual(vari.conditions,form_values) !== true ){
							// 	valid = false;
							// }
							if (valid === true) {
								
								vari_price = parseFloat(vari.price);
								//console.log(vari_price)
							}

						}//first if

					});//first each


					if (vari_price !== null && !isNaN(vari_price)) {
						product.cart.price.base = vari_price + product.cart.price.attr;
						
					}
				}//top if

				product.cart.price.template = {};

				if (product.cart.qty === 0)
					product.cart.qty = 1;


				$('.price').html(lumise.fn.price(product.cart.get_price()));
				//console.log(product.cart.price);

			},
		},
		slug: function (str, decode) {
			if (decode == undefined)
				return encodeURIComponent(str);
			else
				return decodeURIComponent(str);
		},
		fields: {

			render: function (data) {

				var lac = product.data.attributes_cfg[ data.type ];

				if (lac === undefined || lac.render === undefined || lac.render === '')
					return '';

				if (typeof lac.frontend_render != 'function') {
					try {
						lac.frontend_render = Function("data", "$", "product", lac.render);
					} catch (ex) {
						return $('<p>JS Error: field render <b>' + data.type + '</b> :: ' + ex.message + '</p>');
					}
				};
				//console.log(data);
				if (data.type == 'quantity')
					data.required = true;

				if (typeof data.value == 'object')
					data.value = data.value[ 0 ];

				let values = data.values;


				if (typeof data.values == 'string') {
					try { values = JSON.parse(data.values); } catch (ex) { };

				};


				if (data.use_variation === true) {
					data.required = true;
					data.values = { options: [ { value: '', title: 'Choose Option', price: '' } ] };
				};


				if (
					data.use_variation === true &&
					typeof data.allows == 'object' &&
					typeof values == 'object' &&
					typeof values.options == 'object' &&
					values.options.length > 0
				) {
					data.values.options = [];
					values.options.map(function (op) {
						if (
							data.allows.indexOf(op.value) > -1
						) data.values.options.push(op);
					});
				}

				else if (
					data.use_variation === true &&
					typeof data.allows == 'object' &&
					typeof values == 'object' &&
					typeof values.type !== 'undefined' &&
					values.type == 'package' &&
					values.package_options.length > 0
				) {
					//alert('in')
					delete data.values.options;
					data.values = values;

				};

				//console.log(data.values);

				if (data.id === undefined)
					data.id = encodeURIComponent(data.name);
				//field icon
				let field_icon = '';
				if (data.name.localeCompare('Select Your Paper Stock/Thickness') === 0) {
					field_icon = '<img src="assets/images/editor/calc/thickness.jpg">';
				} else if (data.name.localeCompare('Size') === 0) {
					field_icon = '<img src="assets/images/editor/calc/size.jpg">';
				} else if (data.name.localeCompare('Paper Type') === 0) {
					field_icon = '<img src="assets/images/editor/calc/paper_type.jpg">';
				} else if (data.name.localeCompare('Corners') === 0) {
					field_icon = '<img src="assets/images/editor/calc/corners.jpg">';
				} else if (data.name.localeCompare('Finish') === 0) {
					field_icon = '<img src="assets/images/editor/calc/finish.jpg">';
				} else if (data.name.localeCompare('Quantity') === 0) {
					field_icon = '<img src="assets/images/editor/calc/quantity.jpg">';
				} else if (data.name.localeCompare('Production Time') === 0) {
					field_icon = '<img src="assets/images/editor/calc/production.jpg">';
				} else if (data.name.localeCompare('Shipping') === 0) {
					field_icon = '<img src="assets/images/editor/calc/shipping.jpg">';
				}

				//console.log(data);
				var field = $('<div data-type="' + data.type + '" data-id="' + (
					data.id !== undefined ? data.id : ''
				) + '" class="lumise-cart-field field-inline">\
							<div class="lumise_form_group">\
								<span class="lumise-cart-field-label">'+ field_icon +
					(data.name) + ': ' +
					(data.required ? ' <em class="required">*</em>' : '') + '\
								</span>\
								<span class="lumise-cart-tooltip" title=""><img src="assets/images/editor/calc/tool-tip.jpg"></span>\
								<div class="lumise_form_content"></div>\
							</div>\
						</div>'),
					inp = lac.frontend_render(data, $, product);

				field.find('div.lumise_form_content').append(inp);
				
				if (data.variation_image != null && data.variation_image!='' && data.variation_image!=undefined) {
					
					let mim = document.getElementById('mainImage');
					mim.src = data.variation_image;
					
					mim.parentElement.setAttribute('href', data.variation_image);
					$easyzoomAPI.swap(data.variation_image, data.variation_image);
				}

				return field;

			},
		},
	}

});
