<?php
require('autoload.php');
global $lumise, $lumise_helper;

$data = $lumise->connector->get_session('lumise_cart');
$items = isset($data['items']) ? $data['items'] : null;
//echo "<pre>";print_r($items);exit;
$fields = array(
    array('email', 'Billing E-Mail'),
    array('address', 'Street Address'),
    array('zip', 'Zip Code'),
    array('city', 'City'),
    array('country', 'Country')
);

$lumise_helper->process_cart();
$page_title = 'Shopping Cart';
$shppings = $lumise->connector->get_session('shipping_rates');

include(theme('header.php'));
?>
<style>
    .pac-container{
        z-index:9999;
    }
</style>
<div class="lumise-bread">
    <div class="container">
        <h1><?php echo $lumise->lang('Shopping Cart'); ?></h1>
    </div>
</div>
<div class="container">
    <?php if( isset($_GET['ers']) && $_GET['ers']=='shipping_required' ): ?>
        <p class="alert alert-danger">Please provide valid shipping information.</p>
    <?php endif; ?>
    <div id="confirm">
        <?php
        $lumise_helper->show_sys_message();
        ?>
        <?php if(is_array($items) && count($items) > 0):?>
            <div class="span12">
                <div class="wrap-table">
                    <table class="lumise-table sty2">
                        <thead>
                            <tr>
                                <th><?php echo $lumise->lang('Thumbnails'); ?></th>
                                <th><?php echo $lumise->lang('Attributes'); ?></th>
                                <th><?php echo $lumise->lang('Qty'); ?></th>
                                <th><?php echo $lumise->lang('Shipping'); ?></th>
                                <th class="text-right"><?php echo $lumise->lang('Subtotal'); ?></th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php
                            $total = 0;
                            $index = 0;
                            foreach($items as $item):
                            
                                $cart_data = $lumise->lib->get_cart_item_file($item['file']);
                                $meta = $lumise->lib->cart_meta($cart_data);
                                $item = array_merge($item, $cart_data);
                                
                            ?>
                            <tr>
                                <td>
                                    <strong><?php echo $item['product_name'];?></strong>
                                    <hr>
                                    <?php
                                    if(count($item['screenshots'])> 0):
                                        foreach($item['screenshots'] as $image):?>
                                            <img class="d-block mx-auto" width="100" src="<?php echo $lumise->cfg->upload_url.$image; ?>" />
                                        <?php endforeach;
                                    endif;
                                    ?>
                                    <hr>
                                    <div class="mt-4 text-center">
                                        <?php if(false === $item['template']):?>
                                            <a class="btn btn-success text-white btn-sm text-capitalize" href="<?php echo $lumise->cfg->tool_url;?>?product_base=<?php echo $item['product_id'];?>&cart=<?php echo $item['cart_id'];?>" class="edit"><?php echo $lumise->lang('Edit'); ?></a>
                                        <?php endif;?>
                                            <a class="btn btn-danger text-white btn-sm text-capitalize" href="<?php echo $lumise->cfg->url;?>cart.php?action=remove&item=<?php echo $item['cart_id'];?>" class="remove"><?php echo $lumise->lang('Remove'); ?></a>
                                    </div>
                                </td>
                                
                                <td>
                                    <?php foreach($meta as $me): ?>
                                        <p>
                                            <strong><?php echo $me['name']; ?></strong> : <?php echo $me['value']; ?>
                                        </p>
                                    <?php endforeach;?>
                                </td>
                                <td><?php echo $item['qty'];?></td>
                                <!-- Shipping options -->
                                <td>
                                    <div class="well">
                                        <?php $aIndex='p-'.$item['product_id'];
                                         if(isset( $shppings[$aIndex] )): 
                                        
                                            if($shppings[$aIndex]['shipTo']): 
                                                $shipTo = $shppings[$aIndex]['shipTo'];
                                                ?>
                                                <a href="#" data-product-id="<?=$item['product_id']?>" class="setup-shipping text-dark" style="text-transform:capitalize">
                                                    <strong class="d-block">Shipping: <?php echo $shppings[$aIndex]['prefered_method']['code_text']; ?></strong>
                                                    <span class="d-block">Shipping Address:</span>
                                                    <span class="d-block"><?php echo $shipTo['first_name'].' '.$shipTo['last_name']; ?>,</span>
                                                    <span><?php echo $shipTo['address']['line_1'].' '.$shipTo['address']['line_2']; ?>
                                                    <?php echo $shipTo['city'].''.$shipTo['state'].' '.$shipTo['zipcode'].' '.$shipTo['country']; ?></span>
                                                </a>
                                            <?php endif; ?>
                                        <?php else: ?>
                                            <a href="#" data-product-id="<?=$item['product_id']?>" class="setup-shipping" style="text-transform:capitalize"><strong>Setup Shipping Method</strong></a>
                                        <?php endif;?>
                                    </div>
                                </td>
                                
                                <td class="text-right"><?php echo $lumise->lib->price($item['price']['total']);?>
                                    <?php $total += $item['price']['total'];?>
                                </td>
                            </tr>
                            <?php 
                            $index++;
                            endforeach;
                            ?>
                        </tbody>
                        <tfoot>
                            <tr>
                                <td colspan="5" class="text-right">
                                    <strong><?php echo $lumise->lang('Total'); ?></strong>
                                </td>
                                <td class="text-right"><?php echo $lumise->lib->price($total);?></td>
                            </tr>
                        </tfoot>
                    </table>
                </div>
            </div>
            <div class="span12 last">

                <div class="form-actions align-right">
                    <a href="<?php echo $lumise->cfg->url;?>checkout.php" class="btn btn-large btn-primary" id="proceedToCheckout">
                        <?php echo $lumise->lang('Proceed To Checkout'); ?>
                    </a>
                </div>
            </div> <!-- .span8 -->
        <?php else:?>
            <div class="span12">
                <p><?php echo $lumise->lang('Your cart is currently empty.'); ?></p>
            </div>
            <div class="form-actions">
                <a href="<?php echo $lumise->cfg->url;?>" class="btn btn-large btn-primary">
                    <?php echo $lumise->lang('Continue Shopping'); ?>
                </a>
            </div>
        <?php endif;?>
    </div>
</div>

<!-- custom modal -->
<div class="modal fade" id="customModal" tabindex="-1" role="dialog" data-backdrop="static" data-keyboard="false" aria-labelledby="customModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
        
        <div class="modal-body" style="min-height: 300px;">
            <div>
                <form name="shipping-form" id="shipping-form" autocomplete="off">
                    <div class="col-sm-12">
                        <div class="row">
                            <div class="col-sm-6 col-xs-6">
                                <div class="form-group mb-2">
                                    <label for="Find your Address">Find your address</label>
                                    <input type="text" class="form-control input-sm" id="autocompleteAdd" placeholder="start typing to search address" autocomplete="off">
                                </div>
                                <div id="shipping_address_data" style="display:none">
                                    <div class="row">
                                        <div class="col-sm-6">
                                            <div class="form-group mb-2">
                                                <label class="mb-0">First Name</label>
                                                <input type="text" name="first_name" id="first_name" class="form-control input-sm">
                                            </div>
                                        </div>
                                        <div class="col-sm-6">
                                            <div class="form-group mb-2">
                                                <label class="mb-0" for="">Last Name</label>
                                                <input type="text" name="last_name" id="last_name" class="form-control input-sm">
                                            </div>
                                        </div>
                                    </div>

                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">Address Line 1</label>
                                        <input type="text" name="line_1" id="line_1" class="form-control input-sm">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">Address Line 2</label>
                                        <input type="text" name="line_2" id="line_2" class="form-control input-sm">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">City</label>
                                        <input type="text" name="city" readonly id="city" class="form-control input-sm">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">State</label>
                                        <input type="text" name="state" readonly id="state" class="form-control input-sm">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">ZIP/Postal Code</label>
                                        <input type="text" name="zipcode" id="zipcode" class="form-control input-sm">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">Country</label>
                                        <input type="text" name="country" readonly id="country" class="form-control input-sm">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label class="mb-0" for="">Phone</label>
                                        <input type="text" name="phone" id="phone" class="form-control input-sm">
                                    </div>
                                </div>
                            </div>
                            <div class="col-sm-6 col-xs-6">
                                <div class="form-group mb-2">
                                    <label for="">Shipping Method</label>
                                    <select name="shipping_method" class="form-control input-sm" id="shipping_method">
                                        <option value="">Select</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                    <input type="hidden" name="product_id" id="product_id" value="">
                </form>
            </div>
        </div>
        <div class="clearfix"></div>
        <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            <button type="button" class="btn btn-primary saveShipping">Save changes</button>
        </div>
        </div>
    </div>
</div>
<script src="/assets/js/shipping.js"></script>
<script  src="https://polyfill.io/v3/polyfill.min.js?features=default"></script>
<script  src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBCNJ7SMvjZ6TDxW3HI86OdsYdefgTveSA&libraries=places"></script>
<script>
    let autocomplete;
    const componentForm = {
        street_number: "short_name",
        route: "short_name",
        locality: "long_name",
        administrative_area_level_1: "short_name",
        country: "short_name",
        postal_code: "short_name",
    };

    function initAutocomplete() {
        // Create the autocomplete object, restricting the search predictions to
        // geographical location types.
        autocomplete = new google.maps.places.Autocomplete(
            document.getElementById("autocompleteAdd"), {
                types: ["geocode"],
            }
        );
        // Restrict address to country
        // autocomplete.setComponentRestrictions({
        //     country: ["us"],
        // });
        // Avoid paying for data that you don't need by restricting the set of
        // place fields that are returned to just the address components.
        autocomplete.setFields([
            "address_component",
            "formatted_address",
            "place_id",
            "geometry"
        ]);
        // When the user selects an address from the drop-down, populate the
        // address fields in the form.
        autocomplete.addListener("place_changed", fillInAddress);
    }

    function fillInAddress() {
        //display form with all info
        document.getElementById('shipping_address_data').style.display='block';
        
        // Get the place details from the autocomplete object.
        const place = autocomplete.getPlace();
        let selectedPlace = {};
        selectedPlace["formated_address"] = place.formatted_address;
        selectedPlace["place_id"] = place.place_id;
        selectedPlace['lat'] = place.geometry.location.lat();
        selectedPlace['lang'] = place.geometry.location.lng();
        // Get each component of the address from the place details,
        // and then fill-in the corresponding field on the form.
        //console.log(place.address_components);
        for (const component of place.address_components) {
            const addressType = component.types[0];

            if (componentForm[addressType]) {
                const val = component[componentForm[addressType]];
                //document.getElementById(addressType).value = val;
                selectedPlace[addressType] = val;
            }
        }
        // filll in form
        //console.log(selectedPlace);
        document.getElementById('line_1').value = (typeof selectedPlace.street_number==undefined) ? '' :selectedPlace.street_number;
        document.getElementById('line_2').value = selectedPlace.route;
        document.getElementById('zipcode').value    = (typeof selectedPlace.postal_code==undefined) ? '' :selectedPlace.postal_code;
        document.getElementById('city').value   = (typeof selectedPlace.locality==undefined) ? '' :selectedPlace.locality;
        document.getElementById('state').value  = selectedPlace.administrative_area_level_1;
        document.getElementById('country').value = selectedPlace.country; 
        //validateAddress();       
    }
    initAutocomplete();

    //disable Proceed To Checkout button if shipping is not selected
    var crt = JSON.parse(localStorage.getItem('LUMISE-CART-DATA'));
    var shp = JSON.parse(localStorage.getItem('SHIPPING_RATES'));
    
    // if( (Object.keys(crt).length != Object.keys(shp.options).length) ) {
    //     document.getElementById('proceedToCheckout').style.display = 'none';
    // }
    jQuery(document).ready(function($){
        var prodId = null;
        var $modal = $('#customModal');

        $('.setup-shipping').on('click', function(e){

            e.preventDefault();

            prodId = $(this).data('product-id');

            $('#product_id').val(prodId);
            //find if quote is there
            var quote = localStorage.getItem('SHIPPING_RATES');
            if( quote !== null ) {
                //show address form
                document.getElementById('shipping_address_data').style.display='block';

                quote = JSON.parse(quote);

                var qIndex = 'p-'+prodId;
                
                if( typeof quote.options[qIndex] != 'undefined'  ) {

                    var shipTo = quote.options[qIndex].shipTo;
                    
                    document.getElementById('first_name').value = shipTo.first_name;
                    document.getElementById('last_name').value = shipTo.last_name;
                    document.getElementById('line_1').value = (typeof shipTo.address.line_1!='undefined' ? shipTo.address.line_1:'');
                    document.getElementById('line_2').value = (typeof shipTo.address.line_2!='undefined') ? shipTo.address.line_2 :'';
                    document.getElementById('zipcode').value    = (typeof shipTo.zipcode!='undefined') ? shipTo.zipcode:'';
                    document.getElementById('city').value   = shipTo.city;
                    document.getElementById('state').value  = shipTo.state;
                    document.getElementById('country').value = shipTo.country;

                    var shippingMethodList = document.getElementById('shipping_method');
                    shippingMethodList.innerHTML='';
                    
                    
                    if( typeof quote.options[qIndex].shipping != 'undefined' ) {
                        var methods = quote.options[qIndex].shipping;
                        for( j in methods ) {
                            var option = document.createElement('option');
                            if(j==0) {
                                option.setAttribute('selected','selected');
                            }
                            option.value = methods[j].code;
                            option.text = methods[j].code_text+' '+methods[j].cost_text;
                            shippingMethodList.appendChild(option);
                        }
                    }
                }
                
            }

            $modal.modal('show');
        });

        $('#customModal').on('show.bs.modal', function(){
            
        });

        //if address changes, request shipping quotes
        $('body').on('blur', '#line_1, #line_2, #zipcode', function(e){
            
            let line1 = $('.modal-body').find('#line_1');
            let line2 = $('.modal-body').find('#line_2');
            let zipcode = $('.modal-body').find('#zipcode');

            if( line1.val() == '' || line2.val() == '' || zipcode.val() == '' ) {
                //alert('ok');
                $('.modal-body').find('#modalmsg').remove();
                $('.modal-body').prepend('<p id="modalmsg" class="alert alert-danger">Please enter your address</p>');
                return;
            }
            

            requestShipping()
                .then((data) => {
                    console.log(data)
                    updateShippingDropdown(data);
					__btn.button('reset');
                    dLoader('hide');
                    window.location.reload;
                })
                .catch((error) => {
                    console.log(error);
                    dLoader('hide');
                });

        });

        function updateShippingDropdown(res) {

            localStorage.setItem('SHIPPING_RATES', JSON.stringify(res));
            let product_id = 'p-'+document.getElementById('product_id').value;

            var shippingMethodList = document.getElementById('shipping_method');
            shippingMethodList.innerHTML='';

            if( typeof res.options[product_id].shipping !== undefined ) {
                var methods = res.options[product_id].shipping;
                let prefered = res.options[product_id].prefered_method;
               
                for( j in methods ) {
                    var option = document.createElement('option');
                    console.log( j +''+ prefered.code )
                    if(j == parseInt(prefered.code)) {
                        option.setAttribute('selected','selected');
                    }
                    option.value = methods[j].code;
                    option.text = methods[j].code_text+' '+methods[j].cost_text;
                    shippingMethodList.appendChild(option);
                }
            }
        } 


        function requestShipping(task='') {
            return new Promise((resolve, reject) => {

                dLoader();

                var __frm = $('#shipping-form')[0];

                var __nonce = $('meta[name="csrf"]').attr('content');
                var product_id = 'p-'+$('#product_id').val();
                
                // get current calculator values
                $calc_options = {};
                var quote = localStorage.getItem('SHIPPING_RATES');
                if( quote !== null ) {
                    //show address form
                    document.getElementById('shipping_address_data').style.display='block';

                    quote = JSON.parse(quote);
                    //console.log(quote)
                    if( typeof quote.options[product_id] !== undefined ) {
                        calc_options = quote.options[product_id].attributes;
                    }
                }
			
                var __f = new FormData(__frm);
                __f.append('nonce', 'LUMISE-SECURITY:'+__nonce);
                __f.append('ajax', 'backend');
                __f.append('action', 'shipping_quote');
                __f.append('task',task);
                __f.append('page', 'cart');
                __f.append('options', JSON.stringify(calc_options));
						

                $.ajax({
                    url: '/editor.php?lumise-router=ajax',
                    method: 'POST',
                    dataType:'json',
                    cache:false,
                    processData: false,
                    contentType: false,
                    data: __f,
                    statusCode: {
                        403: function(){
                            alert('Error 403');
                        }
                    },
                    success:  function(res) {
                        resolve(res);
                    },
                    error: function(error){
                        reject(error);
                    }
                });
            });
        }

        $('body').on('click','.saveShipping', function(e){

            
            var __btn = $(this);
			
			__btn.button('loading');
			
            requestShipping('save')
                .then((data) => {
                    
                    updateShippingDropdown(data);
					__btn.button('reset');
                    dLoader('hide');
                    window.location.reload();
                    $modal.modal('hide')
                })
                .catch((error) => {
                    console.error(error);
                });
        });
    });
</script>
<?php
include(theme('footer.php'));
$lumise->connector->set_session('lumise_cart', $data);
