<?php
/**
 * 
 */
class LumiseView {
    
    function __construct(){
    }

    public static function product_filters($data, $selected=null) {
        global $lumise;

        if( empty($data) ) {
            return;
        }

        if(strpos($selected, ',') !== false){
            $selected = explode(',', $selected);
        }else{
            $selected = array($selected);
        }
    ?>
        <div class="lumise-filter p-2 border">
            <form method="get" action="<?php echo $lumise->cfg->url; ?>products.php?category_id=<?php echo $_GET['category_id'] ? $lumise->lib->sanitize($_GET['category_id']) :''; ?>&product_filter=" name="filter-form" id="filterform">
            <?php 
            foreach ($data as $filterGroup) {
                ?>
                <div class="w-100 lumise-filter-<?php echo $filterGroup['name'];?> d-block pull-left mb-3">

                    <label class="d-block" style="font-weight:bold;"><?php echo $filterGroup['name']; ?></label>

                    
                         
                    <?php if($filterGroup['group_type']=='color'): ?>
                        <!-- Single button -->
                        <div class="btn-group">
                          <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            <img src="./assets/images/color-box.webp" style="height:30px;">&nbsp;Color <span class="caret"></span>
                          </button>
                          <ul class="dropdown-menu">
                            
                          
                        <?php foreach($filterGroup['filter'] as $filter):?>
                            <li>
                            <span class="d-inline-block pull-left" style="width: 30px;height: 30px;">
                                <input class="hidden" id="<?=$filter['filter_id']?>" type="checkbox" <?php if(in_array($filter['filter_id'], $selected)) { echo 'checked'; } ?> value="<?=$filter['filter_id']?>">
                                <label for="<?=$filter['filter_id']?>" class="d-inline-block border mb-0">
                                    <span 
                                        style="display:block;
                                        width:30px;
                                        height:30px;
                                        background:<?php echo $filter['name'];?>;
                                        border:<?php if( in_array($filter['filter_id'], $selected)) { echo '2px solid #000;'; } ?>
                                        "></span>
                                </label>
                            </span>
                            </li>
                        <?php endforeach; ?>

                            </ul>
                        </div>

                     <?php endif; ?>
                    
                    <?php if($filterGroup['group_type']!='color'): ?>
                        <?php foreach($filterGroup['filter'] as $filter):?>

                            <?php if($filterGroup['group_type']!='color'): ?>

                                <label class="d-block pl-3">
                                    <input class="mr-1" type="checkbox" <?php if(in_array($filter['filter_id'], $selected)) { echo 'checked'; } ?> value="<?=$filter['filter_id']?>"><?php echo $filter['name'];?>
                                </label>
                        
                            <?php endif; ?>

                        <?php endforeach;?>
                    <?php endif; ?>
                </div>
            <?php
            }
            ?>
            </form>
        </div>
        <?php
    }

    private static function make_cols($cols) {
        
        $class = '';
        switch ($cols) {
            case '2':
                $class = 'two_col';
                break;
            case '3':
                $class = 'three_col'; 
                break;
            case '4':
                $class = 'four_col';
                break;
            case '5':
                $class = 'five_col';
                break;
            default:
                $class = 'four_col';
                break;
        }
        return $class;
    }
    
    public static function products($data, $cols=4){
        global $lumise, $lumise_helper;
        @ini_set('display_errors', 'On');

    ?>
    <ul class="<?php echo self::make_cols($cols); ?>">
        <?php foreach ($data as $key => $value) {
            $thumbnail_url = $lumise->cfg->url.'assets/images/not-found.jpg';
            if(!empty($value['thumbnail_url']))
                $thumbnail_url = $value['thumbnail_url'];
            
            $has_template = $lumise_helper->has_template($value);
            ?>
            <li>
                <a href="<?php echo $lumise->cfg->url.'product.php?product_id='.$value['id']; ?>">
                    <figure><img src="<?php echo $thumbnail_url;?>" alt=""><div class="overlay"></div></figure>
                    <div class="content">
                        <?php if(isset($value['name'])) echo '<h3>'.$value['name'].'</h3>';?>
                        <?php if(isset($value['name'])) echo '<span class="lumise-price">'.$lumise->lib->price($value['price']).'</span>';?>
                    </div>
                </a>
                <?php /* ?>
                <div class="lumise-action">
                    <?php if($has_template):?>
                        <a href="<?php echo $lumise->cfg->url.'add-cart.php?product_base='.$value['id']; ?>" class="lumise-add">
	                        <?php echo $lumise->lang('Add to cart'); ?>
	                    </a>
                    <?php endif;?>
                    <a href="<?php echo $lumise->cfg->tool_url.'?product_base='.$value['id']; ?>" class="lumise-custom">
	                    <?php echo $lumise->lang('Customize'); ?>
	                </a>
                </div>
                <?php */ ?>
            </li>
        <?php } ?>
    </ul>
    <?php
    }

    public static function featured_products($data)
    {
        global $lumise, $lumise_helper;

        ?>
        <div class="row">
         <?php foreach ($data as $key => $value) :
            $thumbnail_url = $lumise->cfg->url.'assets/images/not-found.jpg';
            if(!empty($value['thumbnail_url']))
                $thumbnail_url = $value['thumbnail_url'];
            
            $has_template = $lumise_helper->has_template($value);
            ?>
            <div class="col-xs-12 col-sm-3 px-sm-0">
                <div class="featured-product-list">
                    <div class="featured-item">
                        <img src="<?php echo $lumise->cfg->url.'resources/'.$value['thumbnail']; ?>">
                        <a href="<?php echo $lumise->cfg->url.'product.php?product_id='.$value['id']; ?>" class="freatured-overlay">
                            <span>
                                <span class="featured-item-name"><?php echo $value['name'] ?? '';?></span>
                            </span>
                        </a>
                    </div>
                </div>
            </div>

        <?php endforeach; ?>
        </div>

    <?php
    }

    public static function blog_list($data)
    {
        global $lumise, $lumise_helper;

        ?>
        <div class="row">
         <?php foreach ($data as $key => $value) :
            $thumbnail_url = $lumise->cfg->url.'assets/images/not-found.jpg';
            if(!empty($value['thumbnail_url']))
                $thumbnail_url = $value['thumbnail_url'];
            
            $has_template = $lumise_helper->has_template($value);
            ?>
            <div class="col-xs-12 col-sm-3 px-sm-0">
                <div class="featured-product-list">
                    <div class="featured-item">
                        <img src="<?php echo $thumbnail_url; ?>">
                        <a href="<?php echo $lumise->cfg->url.'blog.php?post_id='.$value['id']; ?>" class="freatured-overlay">
                            <span>
                                <span class="featured-item-name"><?php echo $value['title'] ?? '';?></span>
                                <?php /*<span class="featured-item-caption"><?php echo $lumise_helper->word_limiter($value['excerpt'],16);?></span>*/ ?>
                            </span>
                        </a>
                    </div>
                </div>
            </div>

        <?php endforeach; ?>
        </div>

    <?php
    }

    public static function blogs($data)
    {
        global $lumise, $lumise_helper;
        ?>
        <div class="row">
            <div class="col-xs-12 col-sm-10 col-sm-offset-1">
                <div class="row">
                    <?php foreach($data as $key=>$value): ?>
                    <div class="col-xs-12 col-sm-4">
                        <div class="panel panel-default box-cards">
                            <div class="panel-heading">
                                <img class="img-round" src="<?php echo $value['thumbnail_url']; ?>">
                            </div>
                            <div class="panel-body">
                               
                                <div class="blog-summary">
                                    <h2 class="text-left pt-3"><?php echo $value['title'] ?? ''; ?></h2>
                                    <p><?php echo $lumise_helper->word_limiter($value['excerpt'],12) ?? ''; ?></p>
                                    <a href="<?php echo $lumise->cfg->url;?>blog.php?post_id=<?php echo $value['id']?>" class="read_more">Read More</a>
                                </div>
                            </div>
                        </div>
                    </div>
                   <?php endforeach; ?>
                </div>
            </div>
        </div>
        <?php
    }

    public static function templates($data, $cols=4){
        global $lumise;
    ?>
    <ul  class="<?php echo self::make_cols($cols); ?>">
        <?php foreach ($data as $key => $value) {
            $thumbnail_url = $lumise->cfg->url.'assets/images/not-found.jpg';
            if(!empty($value['screenshot']))
                $thumbnail_url = $value['screenshot'];
            ?>
            <li>
                <figure><img src="<?php echo $thumbnail_url;?>" alt=""><div class="overlay"></div></figure>
                <div class="content">
                    <?php if(isset($value['name'])) echo '<h3>'.$value['name'].'</h3>';?>
                    <?php if(isset($value['name'])) echo '<span class="lumise-price">'.$lumise->lib->price($value['price']).'</span>';?>
                </div>
                <?php /*
                <a href="<?php echo $lumise->cfg->editor_url.'?product_id='.$value['id']; ?>">
                    <figure><img src="<?php echo $thumbnail_url;?>" alt=""><div class="overlay"></div></figure>
                    <div class="content">
                        <?php if(isset($value['name'])) echo '<h3>'.$value['name'].'</h3>';?>
                        <?php if(isset($value['name'])) echo '<span class="lumise-price">'.$lumise->lib->price($value['price']).'</span>';?>
                    </div>
                </a>
                */?>
                <div class="lumise-action">
                    <a href="<?php echo $lumise->cfg->tool_url.'?product_base='.$value['id']; ?>" class="lumise-custom"> 
	                    <?php echo $lumise->lang('Customize 2'); ?>
	                </a>
                </div>
                
            </li>
        <?php } ?>
    </ul>
    <?php
    }
    
    public static function categories($limit = 3){
        global $lumise;
        $categories = $lumise->lib->get_categories('products', 0, '`order` DESC');
        $count = 0;
        if(count($categories)>0):
        ?>
        <div class="lumise-categories">
            <div class="container">
                <h2><?php echo $lumise->lang('Categories'); ?></h2>
                <div class="row">
            <?php
                foreach ($categories as $data) {
                    
                    $thumbnail_url = $lumise->cfg->url . 'assets/images/not-found.jpg';
                    if(!empty($data['thumbnail']))
                        $thumbnail_url = $data['thumbnail'];
                    ?>
                    <div class="col-md-4 col-sm-4">
                        <a href="<?php echo $lumise->cfg->url.'products.php?category_id='.$data['id']; ?>" class="lumise-banner">
                            <div class="text-content">
                                <h3><?php if(isset($data['name'])) echo $data['name']?></h3>
                            </div>
                            <img src="<?php echo $thumbnail_url;?>" alt="">
                            <div class="overlay"></div>
                        </a>
                    </div>
                <?php
                
                    $count++;
                    
                    if($limit == $count) break;
                }
            ?>
                </div>
            </div>
        </div>
        <?php
        endif;
    }
    
    public function message(){
        
        $lumise_msg = $this->get_session('lumise_msg');

		if (isset($lumise_msg['status']) && $lumise_msg['status'] == 'error') { ?>

			<div class="tsd_message err">
				<?php foreach ($lumise_msg['errors'] as $val) {
					echo '<em class="tsd_err"><i class="fa fa-times"></i>' . $val . '.</em>';
				} ?>
			</div>

		<?php }

		if (isset($lumise_msg['status']) && $lumise_msg['status'] == 'success') { ?>

			<div class="tsd_message">
				<?php
					echo '<em class="tsd_suc"><i class="fa fa-check"></i>'.(isset($lumise_msg['msg'])? $lumise_msg['msg'] : $lumise->lang('Your data has been successfully saved') ).'</em>';
					
				?>
			</div>

		<?php }
		
		$lumise_msg = array('status' => '');
		$this->set_session('lumise_msg', $lumise_msg);
        
    }
    public static function filter($data, $filters){
        
        
    ?>
    <div class="lumise-filter">
        <?php 
        foreach ($filters as $name => $cfg) {
            ?>
            <div class="lumise-filter-<?php echo $name;?>">
                <?php 
                switch ($cfg['type']) {
                    case 'dropdown':
                        ?>
                        <select name="<?php echo $name;?>" class="lumise-filter-dropdown">
                            <?php foreach($cfg['options'] as $key => $val):?>
                                <option value="<?php echo $key;?>"<?php echo (isset($cfg['val']) && $cfg['val'] == $key)? ' selected="selected"':''?>><?php echo $val;?></option>
                            <?php endforeach;?>
                        </select>
                        <?php
                        break;
                    
                    default:
                        # code...
                        break;
                }
                ?>
            </div>
            <?php
        }
        ?>
    </div>
    <?php
    }

    public static function categroyfilter($data, $fiilter) {
        global $lumise;
        $categories = $lumise->lib->get_categories($type = 'products', $parent = null, $orderby = '`order` ASC', $active = true);
        //echo "<pre>";print_r($categories);exit;
        if( empty($categories) ) {
            return;
        }
    ?>

        <div class="cata-sub-nav">
            <div class="nav-prev arrow" style="display: none;">
                <i class="fa fa-angle-left fa-2x"></i>
            </div>
          
            <ul>
                <?php foreach($categories as $ctg): ?>
                    <li><a href="<?=$lumise->cfg->url?>products.php?category_id=<?=$ctg['id']?>" class="nav-item active"><?=$ctg['name']?></a></li>
                <?php endforeach; ?>
            </ul>
            <div class="nav-next arrow" style="">
                <i class="fa fa-angle-right fa-2x"></i>
            </div>
          
        </div>

        <?php
    }
}
