<?php
class lumise_helper{
    
    function __construct(){
        define("STRING_DELIMITER", " ");
    }


 
    /*
     * @params: String, Integer
     * @return: String
     */
    public function word_limiter($string, $word_limit = 10) {
        $string = strip_tags($string);
        $words = explode(' ', strip_tags($string));
        $return = trim(implode(' ', array_slice($words, 0, $word_limit)));
        if(strlen($return) < strlen($string)){
        $return .= '...';
        }
        return $return;
    }
    
    public function process_cart(){
        
        global $lumise;
        
        if(isset($_REQUEST['action'])){
            switch ($_REQUEST['action']) {
                case 'remove':
                
                    $lumise->lib->remove_cart_item($_REQUEST['item']);
                    $this->sys_msg('Product item was removed.', true);
                    
                    $this->redirect($_SERVER['HTTP_REFERER']);
                    
                    break;
                
                default:
                    # code...
                break;
            }
        }
    }
    
    public function has_template($product_data){
        global $lumise;
        
        $has_template = false;
        $stages = isset($product_data['stages'])? $lumise->lib->dejson($product_data['stages']) : array();
        
        foreach ($stages as $stage => $data) {

            if(
                isset($data->template) &&
                isset($data->template->id) && 
                $data->template->id > 0
            ){
                $has_template = true;
                break;
            }
        }
        return $has_template;
    }
    
    public function qty_extract($options){
        foreach($options as $option)
            if(strpos($option, '-') === true){
                $tmp = explode('-', $option);
                $option = $tmp[0] . ' ('.$tmp[1].')';
            }
        return $options;
    }
    
    public function redirect($url){
        
        if (empty($url))
            return;

        @header("location: " . $url);
        exit();
    }
    
    public function sys_msg($data = '', $clear = false){
        
        if(empty($data) && isset($_SESSION['lumise_sys_msg'])){
            $msg =  implode('<br/>', $_SESSION['lumise_sys_msg']);
            $_SESSION['lumise_sys_msg'] = array();
            
            return $msg;
        }
        if($clear) $_SESSION['lumise_sys_msg'] = array();
        
        $_SESSION['lumise_sys_msg'][] = $data;

    }

    public function show_sys_message(){
        if(isset($_SESSION['lumise_sys_msg']) && count($_SESSION['lumise_sys_msg'])){
            ?>
           <div class="lumise-sys-message lumise_message">
            <?php
            foreach($_SESSION['lumise_sys_msg'] as $msg) echo $msg;
            ?>
            </div>
            <?php
            $_SESSION['lumise_sys_msg'] = array();
        }
    }
    
    public function process_payment($data, $formNonce=null){
        global $lumise;

        $order_data = $data['order_data'];
        //echo "<pre>"; print_r($data);exit;
        if($order_data['payment'] == 'paypal'){
            
            if($lumise->cfg->settings['sanbox_mode']){
                $paypal_url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
            } else $paypal_url = 'https://www.paypal.com/cgi-bin/webscr';
            
            ?>
            <center>
            <p><?php echo $lumise->lang('Your order placed, now you will be redirect to paypal in 5 seconds to progress payment.'); ?></p>
            <form action="<?php echo $paypal_url; ?>" method="post" id="cartCheckout">
                <input type="hidden" name="business" value="<?php echo $lumise->cfg->settings['merchant_id']; ?>">
                
                <input type="hidden" name="cmd" value="_xclick">
                
                <input type="hidden" name="item_name" value="Order #<?php echo $order_data['id']; ?>">
                <input type="hidden" name="item_number" value="<?php echo $order_data['id']; ?>">
                <input type="hidden" name="amount" value="<?php echo $order_data['total']; ?>">
                <input type="hidden" name="currency_code" value="<?php echo $lumise->cfg->settings['currency_code'];?>">
                <input type='hidden' name='cancel_return' value='<?php echo $lumise->cfg->url . PAYPAL_CANCEL;?>'>
                <input type='hidden' name='return' value='<?php echo $lumise->cfg->url . PAYPAL_RETURN;?>'>
                <input type='hidden' name='notify_url' value='<?php echo $lumise->cfg->url . 'paypal_ipn.php';?>'>
                <input type="hidden" name="rm" value="2" />
                <input type="image" name="submit" border="0"
                src="https://www.paypalobjects.com/en_US/i/btn/btn_buynow_LG.gif" alt="PayPal - The safer, easier way to pay online">
                <img alt="" border="0" width="1" height="1" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" >
            </form>
            </center>
            <script>
            window.onload= function(){ 
                setTimeout(function (){
                    document.getElementById('cartCheckout').submit();
                }, 5000);
            };
            </script>
            <?php
            die();
        }
        elseif( $order_data['payment']=='square' ) {
           
            return $this->charge_customer($data, $formNonce);
        }
    }

    public function charge_customer($data, $nonce)
    {
        $client = new \Square\SquareClient([
            'accessToken' => SQUARE_ACCESS_TOKEN,
            'environment' => SQUARE_ENVIRONMENT,
        ]);

        $body_sourceId = $nonce;
        $body_idempotencyKey = uniqid();
        
        $body_amountMoney = new \Square\Models\Money;
        $amountToPay = $data['order_data']['total']*100;
        $body_amountMoney->setAmount( $amountToPay );
        $body_amountMoney->setCurrency( \Square\Models\Currency::USD);
        
        $body = new \Square\Models\CreatePaymentRequest(
            $body_sourceId,
            $body_idempotencyKey,
            $body_amountMoney
        );

        $body->setAutocomplete(true);
        //$body->setOrderId('order_id0');
        //$body->setCustomerId('VDKXEEKPJN48QDG3BGGFAK05P8');
        $body->setLocationId(SQUARE_LOCATION_ID);
        $body->setReferenceId($data['order_data']['id']);
        $body->setNote('Paid for Free.inkgility.com Design, OrderId: '.$data['order_data']['id'].' by '.$data['user_data']['name']);

        try{
            $apiResponse = $client->getPaymentsApi()->createPayment($body);
            
            if($apiResponse->isSuccess()){
                $payment = $apiResponse->getResult()->getPayment();
                //echo "<pre>"; print_r($payment);exit;
                
                $trans_id = $payment->getId();
                $amount   = $payment->getAmountMoney()->getAmount();
                //$paymentStatus  = $payment->getStatus(); 
                //$cardStatus     = $payment->getcardDetails()->getStatus();
                //$card           = $payment->getCardDetails()->getCard();

                // $card_brand     = $card->getCardBrand();
                // $last4__digit   = $card->getLast4();
                // $exp_month      = $card->getExpMonth();
                // $exp_year       = $card->getExpYear();
                // $card_holder    = $card->getCardholderName();
                // $card_type      = $card->getCardType();

                //update database
                global $lumise;
                $db = $lumise->get_db();
                $db->where ('id', $data['order_data']['id'])->update ('orders', array(
                    'txn_id' => $trans_id,
                ));
                
                $db->where ('id', $data['order_data']['id']);
                $db->where ('status', 'pending')->update ('orders', array(
                    'status' => 'complete'
                ));
                return true;

            } else {
                $errors = $apiResponse->getErrors();
                //echo "<pre>"; print_r($errors);exit;
                return ['error' => $this->translateError($errors[0]->getCode())];
            }

        } catch(\Exception $e) {
            $errors = $result->getErrors();
            return ['error' => $this->translateError($errors[0]->getCode())];
        }
    }

    private function translateError($code='')
    {
        $msg="";
        switch ($code) {
            case 'BAD_EXPIRATION':
                $msg="The card expiration date is either missing or incorrectly formatted.";
                break;
            case 'INSUFFICIENT_FUNDS':
                $msg="The payment source has insufficient funds to cover the payment.";
                break;
            case 'CVV_FAILURE':
                $msg="The card issuer declined the request because the CVV value is invalid.";
                break;
            case 'ADDRESS_VERIFICATION_FAILURE':
                $msg="The card issuer declined the request because the postal code is invalid.";
                break;
            case 'PAN_FAILURE':
                $msg="The specified card number is invalid.";
                break;
            case 'EXPIRATION_FAILURE':
                $msg="The card expiration date is either invalid or indicates that the card is expired.";
                break;
            case 'CARD_NOT_SUPPORTED':
                $msg="The card is not supported in the geographic region.";
                break;
            case 'INVALID_PIN':
                $msg="The card issuer declined the request because the PIN is invalid.";
                break;
            case 'INVALID_POSTAL_CODE':
                $msg="The postal code is incorrectly formatted.";
                break;
            case 'TEMPORARY_ERROR':
                $msg="A temporary internal error occurred. You can safely retry the payment.";
                break;
            case 'CARD_EXPIRED':
                $msg="The card issuer declined the request because the card is expired.";
                break;
            default:
                $msg="A temporary internal error occurred. You can safely retry the payment.";
                break;
        }
        return $msg;
    }

    /*Save questionnaires*/
    public function save_qs($qs_labels, $post)
    {
        global $lumise;

        $msg='There is an error with your submission. Please try again';
        if(isset($_POST['nonce'])) {

            if(lumise_secure::check_nonce('LUMISE-SECURITY', $post['nonce'])) {

                                
                $data = [];

                $loopIndex = 0;

                foreach($post as $input_name => $value ) {
                    
                    if( isset($qs_labels[$input_name]) ) {

                        $data['form'] = $post['action_name'];
                        $data['title'][$loopIndex] = $qs_labels[$input_name];

                        if(is_array($value)) {

                            $subArry=[];
                            foreach( $value as $arkey => $arval ) {

                                $subArry[$arkey] = $this->get_uploaded_files($input_name.'['.$arkey.']') ? $this->get_uploaded_files($input_name.'['.$arkey.']') : $arval;
                            }

                            $data['value'][$loopIndex] = serialize($subArry);

                        } else {

                            $data['value'][$loopIndex] = $this->get_uploaded_files($input_name ) ? $this->get_uploaded_files($input_name) : $value;
                        }
                        
                        $loopIndex++;
                    }
                }
                
                if(isset($data['title']) &&  !empty($data['title'])) {
                    if($qsid = $this->store_qs($data) ) {
                        $msg = 'Thank you. We will get in touch with you asap.';

                        if($post['product_base']) {

                            $lumise->redirect($lumise->cfg->url.'add-cart.php?product_base='.$post['product_base'].'&qsid='.$qsid);
                            exit;
                        }
                    }
                }

            } 
            
            //echo "<pre>"; print_r($_POST);exit;
        }
        return $msg;
    }

    function get_uploaded_files($findIndex) {
        $link = null;
        if( isset($_SESSION['uploaded_files']) && !empty($_SESSION['uploaded_files']) ) {

            foreach($_SESSION['uploaded_files'] as $key => $value) {
                if(isset($value[$findIndex])) {
                    $link = $value[$findIndex];
                    break;
                }
            }
        }
        return $link;
    }

    private function store_qs($data)
    {
        global $lumise;

        if(empty($data) || !isset($data['title']) || empty($data['title'])) {
            return false;
        }

        
        $qs_id = $lumise->db->insert('questionnaire', [
            'name' => $data['form'],
            'seen' => 0,
            'created_at' => date('Y-m-d H:i:s'),
        ]);

        $qsChild = [];
        for ($i=0; $i <= count($data['title'])-1 ; $i++) { 
            
            $lumise->db->insert('questionnaire_data', [

                'parent' => $qs_id,
                'label' => $data['title'][$i],
                'value' => $data['value'][$i],
            ]);
        }

        return $qs_id;
    }
}

global $lumise_helper;
$lumise_helper = new lumise_helper();
