<?php
/*
Name: Questionnaires
Description: Product questionnaire
Version: 1.0
Compatible: 1.7.4
*/

class lumise_addon_questionnaire extends lumise_addons {
	
	function __construct() {
		
		global $lumise;
		
		/*
		*	Access core js via your JS function name
		*/
		
		$this->access_corejs('lumise_addon_questionnaire');
		
		/*
		*	Add new component, show in left menu of editor and can config in Lumise -> Settings -> Editor
		*/
		
		// $this->add_component(array(
		// 	"backgrounds" => array(
		// 		"label" => "Filters",
		// 		"icon" => "lumisex-easel",
		// 		"load" => "filters",
		// 		"class" => "lumise-x-thumbn",
		// 		"content" => $this->render_xitems(array(
		// 			"component" => "filters",
		// 			"search" => true,
		// 			"category" => true,
		// 			"preview" => true,
		// 			"price" => true
		// 		))
		// 	)
		// ));
		
		/*
		*	Add new left menu in backend	
		*/
		
		$lumise->add_filter('admin_menus', array(&$this, 'admin_menus'));
		
		/*
		*	Display Lumise page in backend
		*/
		
		$lumise->add_filter('admin_page', array(&$this, 'admin_page'));


	}
		
	
	public function admin_menus($args) {
		
		global $lumise;
		
		$position = 3;

		$id = isset($_GET['id']) ? $_GET['id']:'';
		
		$new_menu = array(
			"questionnaires" => array(
				'title' => $lumise->lang('Questionnaires'),
				'icon'  => '<i class="fa fa-object-group"></i>',
				'child' => array(
					'questionnaires'   => array(
						'type'   => '',
						'title'  => $lumise->lang('Questionnaires'),
						'link'   => $lumise->cfg->admin_url.'lumise-page=questionnaires',
						'hidden' => false,
					),
					'questionnaire' => array(
						'type'   => 'images',
						'title'  => $lumise->lang('View Questionnaire'),
						'link'   => $lumise->cfg->admin_url.'lumise-page=questionnaire&id='.$id,
						'hidden' => true,
					),
					
				),
				'capability' => 'lumise_read_questionnaires'
			)
		);
		
		return array_slice($args, 0, $position, true) + 
			   $new_menu + 
			   array_slice($args, $position, count($args) - 1, true);
			   
	}
	
	public function admin_page($path, $page) {
		
		if ($page == 'questionnaire')
			return dirname(__FILE__).DS.'questionnaire.php';
		else if ($page == 'questionnaires')
			return dirname(__FILE__).DS.'questionnaires.php';
		
		else return $path;
		
	}
	
	/*
		Actions on active or deactive this addon
	*/
	
	static function active() {
		
		global $lumise;
		
		$comps = explode(',', $lumise->cfg->settings['components']);
		
		if (!in_array('questionnaires', $comps))
			array_push($comps, 'questionnaires');
		
		$lumise->set_option('components', implode(',', $comps));
		
		$lumise->db->rawQuery("CREATE TABLE `".$lumise->db->prefix."questionnaire` (
			  `id` int(11) NOT NULL,
			  `name` varchar(45) NOT NULL,
			  `seen` tinyint(2) NOT NULL DEFAULT 0,
			  `created_at` datetime DEFAULT NULL
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;");
		
		$lumise->db->rawQuery("ALTER TABLE `".$lumise->db->prefix."questionnaire` ADD PRIMARY KEY (`id`);");
		$lumise->db->rawQuery("ALTER TABLE `".$lumise->db->prefix."questionnaire` CHANGE `id` id int(11) NOT NULL AUTO_INCREMENT;");
		

		//filters
		$lumise->db->rawQuery("CREATE TABLE `".$lumise->db->prefix."questionnaire_data` (
		  `id` int(11) NOT NULL,
		  `parent` int(11) NOT NULL,
		  `label` text NOT NULL,
		  `value` text NOT NULL
		) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;");
		
		$lumise->db->rawQuery("ALTER TABLE `".$lumise->db->prefix."questionnaire_data` ADD PRIMARY KEY (`id`);");
		$lumise->db->rawQuery("ALTER TABLE `".$lumise->db->prefix."questionnaire_data` CHANGE `id` id int(11) NOT NULL AUTO_INCREMENT;");
		
	}
	
	static function deactive() {
		
		global $lumise;
		
		$comps = explode(',', $lumise->cfg->settings['components']);

		if (in_array('questionnaires', $comps))
			unset($comps[array_search('questionnaires', $comps)]);
		
		$lumise->set_option('questionnaires', implode(',', $comps));
		
	}
	
}