<?php
require('autoload.php');
global $lumise;

$dt_order = isset($_REQUEST['order']) && !empty($_REQUEST['order']) ? $lumise->lib->sanitize($_REQUEST['order']) : 'name_asc';
$current_page = (isset($_GET['tpage']) && ($_GET['tpage'])) ? $lumise->lib->sanitize($_GET['tpage']) : 1;
$cate_id = (isset($_GET['category_id']) && ($_GET['category_id'])) ? $lumise->lib->sanitize($_GET['category_id']) : '';

$product_filter_id = (isset($_GET['product_filter']) && ($_GET['product_filter'])) ? $lumise->lib->sanitize($_GET['product_filter']) : '';


$order_cfg = explode('_', $dt_order);
$orderby = "`{$order_cfg[0]}`";
$ordering = "{$order_cfg[1]}";

$search_filter = array(
    'keyword' => ''
,    'fields' => 'name'
);

$default_filter = array(
    'type' => '',
);
$per_page = 8;
$start = ( $current_page - 1 ) * $per_page;

$productFilterData=[];


if (isset($cate_id) && !empty($cate_id)){ 
    $data = $lumise->lib->get_by_category($cate_id, $orderby, $ordering, $per_page, $start, 'products', array('active'=> 1,'is_single'=>'0'), $product_filter_id);

    //product filters
    $productFilterData = $lumise->lib->get_product_filters_byCategory($cate_id);

}else{
    $data = $lumise->lib->get_rows('products', $search_filter, $orderby, $ordering, $per_page, $start, array('active'=> 1,'is_single'=>'0'), '');
}



$data['total_page'] = ceil($data['total_count'] / $per_page);
$config = array(
    'current_page'  => $current_page,
    'total_record'  => $data['total_count'],
    'total_page'    => $data['total_page'],
    'limit'         => $per_page,
    'link_full'     => $lumise->cfg->url.'products.php?tpage={page}'.(!empty($cate_id) ? '&category_id='.$cate_id : ''),
    'link_first'    => $lumise->cfg->url.'products.php'.(!empty($cate_id) ? '?category_id='.$cate_id : ''),
);
$lumise_pagination = new lumise_pagination();
$lumise_pagination->init($config);

$page_title = 'Products';
include(theme('header.php'));

$categories = $lumise->lib->get_categories('products');
$cat_options = [];//array('' => '-- Categories --');
foreach($categories as $cat){
    $cat_options[$cat['id']] = $cat['name'];
}

$filters = array(
    'category_id' => array(
        'type' => 'list',
        'options' => $cat_options,
        'default' => '',
        'val' => $cate_id
    ),
    // 'order' => array(
    //     'type' => 'dropdown',
    //     'options' => array(
    //         '' => '-- Sortby --',
    //         'name_asc' => 'Name Asc',
    //         'name_desc' => 'Name Desc',
    //         'order_asc' => 'Order Asc',
    //         'order_desc' => 'Order Desc',
    //     ),
    //     'default' => '',
    //     'val' => $dt_order
    // )
);

?>
<style type="text/css">
.cata-sub-nav {
    background: #fff;
    padding: 20px 15px 20px;
    margin: 0 37px;
    /* Make this scrollable when needed */
    overflow-x: auto;
    /* We don't want vertical scrolling */
    overflow-y: hidden;
    /* Make an auto-hiding scroller for the 3 people using a IE */
    -ms-overflow-style: -ms-autohiding-scrollbar;
    /* For WebKit implementations, provide inertia scrolling */
    -webkit-overflow-scrolling: touch;
    /* We don't want internal inline elements to wrap */
    white-space: nowrap;
    /* Remove the default scrollbar for WebKit implementations */
    scroller-behavior:smooth;
}
.cata-sub-nav::-webkit-scrollbar {
    display: none;
}
.cata-sub-nav ul {
    margin: 0;
    display: flex;
    -webkit-padding-start: 0px;
    justify-content: center;
    align-items: center;
}
.cata-sub-nav li {
    display: inline-table;
    margin: 0 2px;
    font-size: 16px;
}
a.nav-item {
    padding: 10px 15px;
    cursor: pointer;
    text-decoration: none;
    color: #000;
    background: #ddd;
    border-radius: 4px;
} 
.arrow{
    background: #ddd;
}
.nav-prev, .nav-next{
    width: 30px;
    height: 35px;
    position: absolute;
    margin-top: 0;
    top: 15px;
    background: #ddd;
    text-align: center;
    line-height: 3.4;
    cursor: pointer;

}
.nav-prev {
    left: 15px;
}
.nav-next {
    right: 15px;
}
.lumise-filter label{
    cursor: pointer;
    
}
.lumise-filter ul.dropdown-menu{
    min-width: 240px;
}
</style>
<script type="text/javascript">
    jQuery(document).ready(function($) {

        $(".nav-next, .nav-prev").hide();

        $(".cata-sub-nav").on('scroll', function() {
            $val = $(this).scrollLeft();

            if($(this).scrollLeft() + $(this).innerWidth()>=$(this)[0].scrollWidth){
                $(".nav-next").hide();
            } else {
                $(".nav-next").show();
            }

            if($val == 0){
                $(".nav-prev").hide();
            } else {
                $(".nav-prev").show();
            }
        });
        //console.log( 'init-scroll: ' + $(".nav-next").scrollLeft() );
        $(".nav-next").on("click", function(){
            $(".cata-sub-nav").animate( { scrollLeft: '+=460' }, 500);
            
        });
        $(".nav-prev").on("click", function(){
            $(".cata-sub-nav").animate( { scrollLeft: '-=460' }, 500);
        });

    });
</script>
<div class="lumise-bread product-bread" style="background:url('./assets/images/get-started.jpg');">
    <div class="container">
        <h1 class="text-center text-white"><?php echo $lumise->lang('Standard Metalic Finish'); ?></h1>
    </div>
</div>

<div class="lumise-products pt-3">
    <div class="category-filters d-flex align-items-center justify-content-center
    ">
        <div class="col-xs-12 col-sm-12">
            
            <?php LumiseView::categroyfilter($data, $filters); ?>
            
        </div>
    </div>
    <div class="lumise-list">
        <div class="container">
           
                <div class="col-xs-12 col-sm-3">
                    <?php LumiseView::product_filters($productFilterData,$product_filter_id); ?>
                </div>
                <div class="col-xs-12 col-sm-9">
                    <?php LumiseView::products($data['rows']);?>
                </div>
            
        </div>
    </div>
    <div class="container">
        <div class="lumise_pagination"><?php echo $lumise_pagination->pagination_html(); ?></div>
    </div>
</div>
        
<?php include(theme('footer.php'));?>
